#include <imsls.h>
#include <stdio.h>
#include <stdlib.h>
extern FILE* imsls_fopen(char* filename, char* mode);
extern int imsls_fclose(FILE* file);

int main(){
   FILE *file;
   char *filename = "NeuralNetworkEx2.txt";
   int i, j, n;
   int n_patterns       =13;
   int n_inputs         =4; 
   int n_categorical    =0; 
   int n_continuous     =4; 
   int n_outputs        =1;
   int n_networks       =0;
   int *categoricalAtt=NULL;
   float ss3, ss4;
   float cont4[4*13], y[13], contAtt4[4];
   float cont3[3*13];
   float *draperSmithData;
   float forecast[1], forecasts[2*13];
   Imsls_f_NN_Network **neural_network;
   draperSmithData = imsls_f_data_sets(5,0);
   
   for(i=0; i < n_patterns; i++){
      y[i] = draperSmithData[5*i+4];
      for(j=0; j<n_continuous; j++){
         cont4[i*n_continuous+j] = draperSmithData[5*i+j];
         if(j<3) cont3[i*3+j] = draperSmithData[5*i+j];
      }
   }
   
   /* open filestream */
   file = imsls_fopen(filename, "r");
   printf("File %s Opened\n", filename);
   /* Read the number of network being placed into this file */
   fscanf(file, "%d", &n_networks);
   printf("File contains %d neural networks\n", n_networks);
   neural_network = (Imsls_f_NN_Network **) malloc(n_networks*
      sizeof(Imsls_f_NN_Network *));
   printf("Reading Networks and Preparing Forecasts...\n");
   for(n=0; n<n_networks; n++){
      neural_network[n] = imsls_f_mlff_network_read(NULL, 
                              IMSLS_PRINT, IMSLS_FILE, file, 0);
      n_continuous = neural_network[n]->layers[0].n_nodes;
      printf("Preparing forecasts for network with");
      printf(" %d continuous attributes\n", n_continuous);
      for(i=0; i<n_patterns; i++){
         for(j=0; j<4; j++) contAtt4[j] = cont4[i*4+j];
         imsls_f_mlff_network_forecast(neural_network[n],
                              n_categorical, n_continuous, 
                              categoricalAtt, contAtt4, 
                              IMSLS_RETURN_USER, forecast, 0);
         forecasts[n*n_patterns + i] = forecast[0];
      }
   }
   
   imsls_fclose(file);
   printf("File %s Closed.\n\n", filename);
   printf("                                           ");
   printf("FORECAST  FORECAST\n");
   printf("OBS    X1      X2      X3      X4      Y   ");
   printf("n_cont=3  n_cont=4\n");
   ss4 = 0;
   ss3 = 0;
   for(i=0; i<n_patterns; i++) {
      ss4 += (y[i]-forecasts[i])*(y[i]-forecasts[i]);
      ss3 += (y[i]-forecasts[n_patterns+i])*
             (y[i]-forecasts[n_patterns+i]);
      printf("%2d %7.2f %7.2f %7.2f %7.2f %7.2f %7.2f %9.2f\n", 
             i, cont4[i*4], cont4[i*4+1], cont4[i*4+2], cont4[i*4+3], 
             y[i], forecasts[n_patterns+i], forecasts[i]);
   }
   printf("Sum of Squared Residuals for X1-X3: %7.2f\n", ss3);
   printf("Sum of Squared Residuals for X1-X4: %7.2f\n", ss4);

}
